import java.io.*;

import dk.vajhoej.record.*;
import dk.vajhoej.isam.*;
import dk.vajhoej.isam.local.*;
import dk.vajhoej.isam.remote.*;

public class Test2 {
    public static void test(IsamSource isam) throws IsamException, RecordException {
        System.out.println("Lookup by first key:");
        Data2 o1 = isam.read(Data2.class, new Key<Integer>(0, 3));
        System.out.println(o1.getId1() + " " + o1.getId2() +
                           " " + o1.getVal1() + " " + o1.getVal2() + " " + o1.getVal3() +
                           " " + o1.getVal4().getVal4a() + " " + o1.getVal4().getVal4b());
        System.out.println("Lookup by second key:");
        Data2 o2 = isam.read(Data2.class, new Key<String>(1, "K017"));
        System.out.println(o2.getId1() + " " + o2.getId2() +
                           " " + o2.getVal1() + " " + o2.getVal2() + " " + o2.getVal3() +
                           " " + o2.getVal4().getVal4a() + " " + o2.getVal4().getVal4b());
    }
    public static void main(String[] args) {
        try {
            System.out.println("**** 2 key fields and struct with struct field ****");
            System.out.println("local");
            System.out.println("=====");
            IsamSource local = new LocalIsamSource("data2.isq", "dk.vajhoej.vms.rms.IndexSequential", true);
            test(local);
            local.close();
            if(args.length > 0 && args[0].toLowerCase().equals("noremote")) System.exit(0);
            System.out.print("Start server and press return...");
            System.in.read();
            System.out.println("remote");
            System.out.println("======");
            IsamSource remote = new RemoteIsamSource("localhost", 10002);
            test(remote);
            remote.close();
        } catch(Exception ex) {
            ex.printStackTrace();
        }
    }
}
